package com.company;

import java.util.LinkedList;

public class Cola {
    private int MAX_ELEMENTOS;
    LinkedList<Integer> cola;

    public Cola(int max) {
        cola = new LinkedList<Integer>();
        this.MAX_ELEMENTOS = max;
    }

    /* En realidad, si estamos seguro de que nadie
    llamará a este método podriamos ponerla como no
    synchronized*/
    public synchronized boolean estaVacia() {
        boolean resultado = false;

        int numElementos = cola.size();
        if (numElementos == 0) {
            resultado = true;
        }
        return resultado;
    }

    /* Igual que antes, si estamos seguro de que nadie
    llamará a este método podriamos ponerla como no
    synchronized*/
    public synchronized boolean estaLlena() {
        boolean resultado = false;

        int numElementos = cola.size();
        if (numElementos == this.MAX_ELEMENTOS) {
            resultado = true;
        }
        return resultado;
    }

    /* Devuelve true si se pudo hacer y false si no se pudo*/
    public synchronized boolean encolar(int valor, int n) {
        boolean resultado = true;

        if (estaLlena()) {
            resultado = false;
        } else {
            cola.addLast(valor);
            System.out.println("Productor " + n + " encoló el número:" + valor);
            leer();
            System.out.println();
        }
        return resultado;
    }

    public synchronized int desencolar(int n) {
        /* Necesitamos un número especial que actúe
        como comprobador de errores
        */
        int resultado = -1;

        if (!estaVacia()) {
            resultado = cola.removeFirst();
            System.out.println("Consumidor " + n + " recuperó el número: " + resultado);
        }
        return resultado;
    }

    public synchronized void leer() {
        for (int i = 0; i < cola.size(); i ++) {
            System.out.print(cola.get(i) + ", ");
        }
    }

}

