package com.company;

public class Main {


    public static void main(String[] args) throws InterruptedException {
        int MAX_PRODUCTORES = 2;
        int MAX_CONSUMIDORES = 3;
        int MAX_ELEMENTOS = 4;

        Thread[] hilosProductor;
        Thread[] hilosConsumidor;

        hilosProductor = new Thread[MAX_PRODUCTORES + 1];
        hilosConsumidor = new Thread[MAX_CONSUMIDORES + 1];

        Cola colaCompartida = new Cola(MAX_ELEMENTOS);

        /*Construimos los productores*/
        for (int i = 1; i <= MAX_PRODUCTORES; i ++) {
            Productor productor = new Productor(colaCompartida, i);
            hilosProductor[i] = new Thread(productor);
            hilosProductor[i].start();
        }
        /*Construimos los consumidores*/
        for (int i = 1; i <= MAX_CONSUMIDORES; i ++) {
            Consumidor consumidor = new Consumidor(colaCompartida, i);
            hilosConsumidor[i] = new Thread(consumidor);
            hilosConsumidor[i].start();
        }

        /* Esperamos a que acaben todos los hilos,
           primero productores y luego consumidores
        */
        for (int i = 1; i <= MAX_PRODUCTORES; i ++) {
            hilosProductor[i].join();
        }
        for (int i = 1; i <= MAX_CONSUMIDORES; i ++) {
            hilosConsumidor[i].join();
        }
    }
}
